function [ new_pos, new_vel ] = COMPUTE_NEW_POS( pos, vel )

global ps
global epso_par
% Computes new position for the particles and updates velocity
new_pos = pos + vel;
new_vel = vel;

% Checks for similarity and forces different integer solutions
for j = 1 : 6
index = ps.D*(j-1);
	tmp_pos_1 = rounding( pos( 1, index+ps.D_cont:index+ps.D ) );
	tmp_pos_2 = rounding( new_pos( 1, index+ps.D_cont:index+ps.D ) );
	if isequal(tmp_pos_1,tmp_pos_2)
		i = index + ps.D_cont + randi( ps.D_disc, 1 );
		if i <= index + ps.D_cont + ps.n_OLTC
			if rand() < 0.5
				new_pos( 1, i ) = rounding( new_pos( 1, i ) ) + 1;
			else
				new_pos( 1, i ) = rounding( new_pos( 1, i ) ) - 1;
			end
		else
			new_pos( 1, i ) = 1 - rounding( new_pos( 1, i ) );
		end
	end
end

for j = 1 : ps.n_gen_PG
	if rand() < 0.5
		first_per = 1;
	else
		first_per = 0;
	end
	for i = 1 : 5
		iper = i;
		factor = betarnd(epso_par.beta,epso_par.beta);
		if first_per == 1
			new_pos(1, j + ( iper - 1 ) * ps.D ) = new_pos(1, j + iper * ps.D ) * factor + new_pos(1, j + ( iper - 1 ) * ps.D ) * (1-factor);
		else
			new_pos(1, j + iper * ps.D ) = new_pos(1, j + iper * ps.D ) * factor + new_pos(1, j + ( iper - 1 ) * ps.D ) * (1-factor);
		end
	end
end

end